diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/udp-l4-protocol.cc ns-3.40/src/internet/model/udp-l4-protocol.cc
--- ns-3.39/src/internet/model/udp-l4-protocol.cc	2023-07-05 14:23:47.861427500 -0700
+++ ns-3.40/src/internet/model/udp-l4-protocol.cc	2023-09-27 13:30:37.666839100 -0700
@@ -382,8 +382,7 @@
     }
 
     packet->RemoveHeader(udpHeader);
-    for (Ipv4EndPointDemux::EndPointsI endPoint = endPoints.begin(); endPoint != endPoints.end();
-         endPoint++)
+    for (auto endPoint = endPoints.begin(); endPoint != endPoints.end(); endPoint++)
     {
         (*endPoint)->ForwardUp(packet->Copy(), header, udpHeader.GetSourcePort(), interface);
     }
@@ -422,8 +421,7 @@
         NS_LOG_LOGIC("RX_ENDPOINT_UNREACH");
         return IpL4Protocol::RX_ENDPOINT_UNREACH;
     }
-    for (Ipv6EndPointDemux::EndPointsI endPoint = endPoints.begin(); endPoint != endPoints.end();
-         endPoint++)
+    for (auto endPoint = endPoints.begin(); endPoint != endPoints.end(); endPoint++)
     {
         (*endPoint)->ForwardUp(packet->Copy(), header, udpHeader.GetSourcePort(), interface);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/udp-socket-factory-impl.h ns-3.40/src/internet/model/udp-socket-factory-impl.h
--- ns-3.39/src/internet/model/udp-socket-factory-impl.h	2023-07-05 14:23:47.861427500 -0700
+++ ns-3.40/src/internet/model/udp-socket-factory-impl.h	2023-09-27 13:30:37.666839100 -0700
@@ -19,8 +19,9 @@
 #ifndef UDP_SOCKET_FACTORY_IMPL_H
 #define UDP_SOCKET_FACTORY_IMPL_H
 
+#include "udp-socket-factory.h"
+
 #include "ns3/ptr.h"
-#include "ns3/udp-socket-factory.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/udp-socket-impl.h ns-3.40/src/internet/model/udp-socket-impl.h
--- ns-3.39/src/internet/model/udp-socket-impl.h	2023-07-05 14:23:47.861427500 -0700
+++ ns-3.40/src/internet/model/udp-socket-impl.h	2023-09-27 13:30:37.666839100 -0700
@@ -20,14 +20,14 @@
 #define UDP_SOCKET_IMPL_H
 
 #include "icmpv4.h"
+#include "ipv4-interface.h"
+#include "udp-socket.h"
 
 #include "ns3/callback.h"
 #include "ns3/ipv4-address.h"
-#include "ns3/ipv4-interface.h"
 #include "ns3/ptr.h"
 #include "ns3/socket.h"
 #include "ns3/traced-callback.h"
-#include "ns3/udp-socket.h"
 
 #include <queue>
 #include <stdint.h>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/test/global-route-manager-impl-test-suite.cc ns-3.40/src/internet/test/global-route-manager-impl-test-suite.cc
--- ns-3.39/src/internet/test/global-route-manager-impl-test-suite.cc	2023-07-05 14:23:47.861427500 -0700
+++ ns-3.40/src/internet/test/global-route-manager-impl-test-suite.cc	2023-09-27 13:30:37.666839100 -0700
@@ -60,7 +60,7 @@
 
     for (int i = 0; i < 100; ++i)
     {
-        SPFVertex* v = new SPFVertex;
+        auto v = new SPFVertex;
         v->SetDistanceFromRoot(std::rand() % 100);
         candidate.Push(v);
     }
@@ -88,18 +88,17 @@
     //  link2:  10.1.3.1/30, 10.1.3.2/30
     //
     // Router 0
-    GlobalRoutingLinkRecord* lr0 =
-        new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
-                                    "0.0.0.2",  // router ID 0.0.0.2
-                                    "10.1.1.1", // local ID
-                                    1);         // metric
-
-    GlobalRoutingLinkRecord* lr1 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
-                                                               "10.1.1.1",
-                                                               "255.255.255.252",
-                                                               1);
+    auto lr0 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
+                                           "0.0.0.2",  // router ID 0.0.0.2
+                                           "10.1.1.1", // local ID
+                                           1);         // metric
+
+    auto lr1 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
+                                           "10.1.1.1",
+                                           "255.255.255.252",
+                                           1);
 
-    GlobalRoutingLSA* lsa0 = new GlobalRoutingLSA();
+    auto lsa0 = new GlobalRoutingLSA();
     lsa0->SetLSType(GlobalRoutingLSA::RouterLSA);
     lsa0->SetLinkStateId("0.0.0.0");
     lsa0->SetAdvertisingRouter("0.0.0.0");
@@ -107,18 +106,17 @@
     lsa0->AddLinkRecord(lr1);
 
     // Router 1
-    GlobalRoutingLinkRecord* lr2 =
-        new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
-                                    "0.0.0.2",
-                                    "10.1.2.1",
-                                    1);
-
-    GlobalRoutingLinkRecord* lr3 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
-                                                               "10.1.2.1",
-                                                               "255.255.255.252",
-                                                               1);
+    auto lr2 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
+                                           "0.0.0.2",
+                                           "10.1.2.1",
+                                           1);
+
+    auto lr3 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
+                                           "10.1.2.1",
+                                           "255.255.255.252",
+                                           1);
 
-    GlobalRoutingLSA* lsa1 = new GlobalRoutingLSA();
+    auto lsa1 = new GlobalRoutingLSA();
     lsa1->SetLSType(GlobalRoutingLSA::RouterLSA);
     lsa1->SetLinkStateId("0.0.0.1");
     lsa1->SetAdvertisingRouter("0.0.0.1");
@@ -126,40 +124,37 @@
     lsa1->AddLinkRecord(lr3);
 
     // Router 2
-    GlobalRoutingLinkRecord* lr4 =
-        new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
-                                    "0.0.0.0",
-                                    "10.1.1.2",
-                                    1);
-
-    GlobalRoutingLinkRecord* lr5 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
-                                                               "10.1.1.2",
-                                                               "255.255.255.252",
-                                                               1);
-
-    GlobalRoutingLinkRecord* lr6 =
-        new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
-                                    "0.0.0.1",
-                                    "10.1.2.2",
-                                    1);
-
-    GlobalRoutingLinkRecord* lr7 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
-                                                               "10.1.2.2",
-                                                               "255.255.255.252",
-                                                               1);
-
-    GlobalRoutingLinkRecord* lr8 =
-        new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
-                                    "0.0.0.3",
-                                    "10.1.3.2",
-                                    1);
-
-    GlobalRoutingLinkRecord* lr9 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
-                                                               "10.1.3.2",
-                                                               "255.255.255.252",
-                                                               1);
+    auto lr4 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
+                                           "0.0.0.0",
+                                           "10.1.1.2",
+                                           1);
+
+    auto lr5 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
+                                           "10.1.1.2",
+                                           "255.255.255.252",
+                                           1);
+
+    auto lr6 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
+                                           "0.0.0.1",
+                                           "10.1.2.2",
+                                           1);
+
+    auto lr7 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
+                                           "10.1.2.2",
+                                           "255.255.255.252",
+                                           1);
+
+    auto lr8 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
+                                           "0.0.0.3",
+                                           "10.1.3.2",
+                                           1);
+
+    auto lr9 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
+                                           "10.1.3.2",
+                                           "255.255.255.252",
+                                           1);
 
-    GlobalRoutingLSA* lsa2 = new GlobalRoutingLSA();
+    auto lsa2 = new GlobalRoutingLSA();
     lsa2->SetLSType(GlobalRoutingLSA::RouterLSA);
     lsa2->SetLinkStateId("0.0.0.2");
     lsa2->SetAdvertisingRouter("0.0.0.2");
@@ -171,19 +166,17 @@
     lsa2->AddLinkRecord(lr9);
 
     // Router 3
-    GlobalRoutingLinkRecord* lr10 =
-        new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
-                                    "0.0.0.2",
-                                    "10.1.2.1",
-                                    1);
-
-    GlobalRoutingLinkRecord* lr11 =
-        new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
-                                    "10.1.2.1",
-                                    "255.255.255.252",
-                                    1);
+    auto lr10 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
+                                            "0.0.0.2",
+                                            "10.1.2.1",
+                                            1);
+
+    auto lr11 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
+                                            "10.1.2.1",
+                                            "255.255.255.252",
+                                            1);
 
-    GlobalRoutingLSA* lsa3 = new GlobalRoutingLSA();
+    auto lsa3 = new GlobalRoutingLSA();
     lsa3->SetLSType(GlobalRoutingLSA::RouterLSA);
     lsa3->SetLinkStateId("0.0.0.3");
     lsa3->SetAdvertisingRouter("0.0.0.3");
@@ -191,7 +184,7 @@
     lsa3->AddLinkRecord(lr11);
 
     // Test the database
-    GlobalRouteManagerLSDB* srmlsdb = new GlobalRouteManagerLSDB();
+    auto srmlsdb = new GlobalRouteManagerLSDB();
     srmlsdb->Insert(lsa0->GetLinkStateId(), lsa0);
     srmlsdb->Insert(lsa1->GetLinkStateId(), lsa1);
     srmlsdb->Insert(lsa2->GetLinkStateId(), lsa2);
@@ -201,7 +194,7 @@
                           "The Ipv4Address is not stored as the link state ID");
 
     // next, calculate routes based on the manually created LSDB
-    GlobalRouteManagerImpl* srm = new GlobalRouteManagerImpl();
+    auto srm = new GlobalRouteManagerImpl();
     srm->DebugUseLsdb(srmlsdb); // manually add in an LSDB
     // Note-- this will succeed without any nodes in the topology
     // because the NodeList is empty
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/test/icmp-test.cc ns-3.40/src/internet/test/icmp-test.cc
--- ns-3.39/src/internet/test/icmp-test.cc	2023-07-05 14:23:47.861427500 -0700
+++ ns-3.40/src/internet/test/icmp-test.cc	2023-09-27 13:30:37.666839100 -0700
@@ -399,7 +399,7 @@
 IcmpV6EchoReplyTestCase::SendData(Ptr<Socket> socket, Ipv6Address dst)
 {
     Ptr<Packet> p = Create<Packet>();
-    Icmpv6Echo echo(1);
+    Icmpv6Echo echo(true);
     echo.SetSeq(1);
     echo.SetId(0XB1ED);
     p->AddHeader(echo);
@@ -537,7 +537,7 @@
 IcmpV6TimeExceedTestCase::SendData(Ptr<Socket> socket, Ipv6Address dst)
 {
     Ptr<Packet> p = Create<Packet>();
-    Icmpv6Echo echo(1);
+    Icmpv6Echo echo(true);
     echo.SetSeq(1);
     echo.SetId(0XB1ED);
     p->AddHeader(echo);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/test/ipv4-address-generator-test-suite.cc ns-3.40/src/internet/test/ipv4-address-generator-test-suite.cc
--- ns-3.39/src/internet/test/ipv4-address-generator-test-suite.cc	2023-07-05 14:23:47.861427500 -0700
+++ ns-3.40/src/internet/test/ipv4-address-generator-test-suite.cc	2023-09-27 13:30:37.666839100 -0700
@@ -323,18 +323,28 @@
     Ipv4AddressGenerator::AddAllocated("0.0.0.16");
 
     Ipv4AddressGenerator::TestMode();
+    bool allocated = Ipv4AddressGenerator::IsAddressAllocated("0.0.0.21");
+    NS_TEST_EXPECT_MSG_EQ(allocated, false, "0.0.0.21 should not be already allocated");
     bool added = Ipv4AddressGenerator::AddAllocated("0.0.0.21");
     NS_TEST_EXPECT_MSG_EQ(added, true, "400");
 
+    allocated = Ipv4AddressGenerator::IsAddressAllocated("0.0.0.4");
+    NS_TEST_EXPECT_MSG_EQ(allocated, true, "0.0.0.4 should be already allocated");
     added = Ipv4AddressGenerator::AddAllocated("0.0.0.4");
     NS_TEST_EXPECT_MSG_EQ(added, false, "401");
 
+    allocated = Ipv4AddressGenerator::IsAddressAllocated("0.0.0.9");
+    NS_TEST_EXPECT_MSG_EQ(allocated, true, "0.0.0.9 should be already allocated");
     added = Ipv4AddressGenerator::AddAllocated("0.0.0.9");
     NS_TEST_EXPECT_MSG_EQ(added, false, "402");
 
+    allocated = Ipv4AddressGenerator::IsAddressAllocated("0.0.0.16");
+    NS_TEST_EXPECT_MSG_EQ(allocated, true, "0.0.0.16 should be already allocated");
     added = Ipv4AddressGenerator::AddAllocated("0.0.0.16");
     NS_TEST_EXPECT_MSG_EQ(added, false, "403");
 
+    allocated = Ipv4AddressGenerator::IsAddressAllocated("0.0.0.21");
+    NS_TEST_EXPECT_MSG_EQ(allocated, true, "0.0.0.21 should be already allocated");
     added = Ipv4AddressGenerator::AddAllocated("0.0.0.21");
     NS_TEST_EXPECT_MSG_EQ(added, false, "404");
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/test/ipv4-global-routing-test-suite.cc ns-3.40/src/internet/test/ipv4-global-routing-test-suite.cc
--- ns-3.39/src/internet/test/ipv4-global-routing-test-suite.cc	2023-07-05 14:23:47.865427500 -0700
+++ ns-3.40/src/internet/test/ipv4-global-routing-test-suite.cc	2023-09-27 13:30:37.666839100 -0700
@@ -894,9 +894,7 @@
 
 Ipv4DynamicGlobalRoutingTestCase::~Ipv4DynamicGlobalRoutingTestCase()
 {
-    std::vector<std::pair<Ptr<Socket>, bool>>::iterator iter;
-
-    for (iter = m_sendSocks.begin(); iter != m_sendSocks.end(); iter++)
+    for (auto iter = m_sendSocks.begin(); iter != m_sendSocks.end(); iter++)
     {
         if (iter->second)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/test/ipv4-rip-test.cc ns-3.40/src/internet/test/ipv4-rip-test.cc
--- ns-3.39/src/internet/test/ipv4-rip-test.cc	2023-07-05 14:23:47.865427500 -0700
+++ ns-3.40/src/internet/test/ipv4-rip-test.cc	2023-09-27 13:30:37.666839100 -0700
@@ -558,7 +558,7 @@
         std::list<RipRte> rtes = hdr.GetRteList();
 
         // validate the RTEs before processing
-        for (std::list<RipRte>::iterator iter = rtes.begin(); iter != rtes.end(); iter++)
+        for (auto iter = rtes.begin(); iter != rtes.end(); iter++)
         {
             if (iter->GetPrefix() == "10.0.1.0")
             {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/test/ipv6-address-generator-test-suite.cc ns-3.40/src/internet/test/ipv6-address-generator-test-suite.cc
--- ns-3.39/src/internet/test/ipv6-address-generator-test-suite.cc	2023-07-05 14:23:47.865427500 -0700
+++ ns-3.40/src/internet/test/ipv6-address-generator-test-suite.cc	2023-09-27 13:30:37.666839100 -0700
@@ -315,18 +315,28 @@
     Ipv6AddressGenerator::AddAllocated("0::0:16");
 
     Ipv6AddressGenerator::TestMode();
+    bool allocated = Ipv6AddressGenerator::IsAddressAllocated("0::0:21");
+    NS_TEST_EXPECT_MSG_EQ(allocated, false, "0::0:21 should not be already allocated");
     bool added = Ipv6AddressGenerator::AddAllocated("0::0:21");
     NS_TEST_EXPECT_MSG_EQ(added, true, "address should get allocated");
 
+    allocated = Ipv6AddressGenerator::IsAddressAllocated("0::0:4");
+    NS_TEST_EXPECT_MSG_EQ(allocated, true, "0::0:4 should be already allocated");
     added = Ipv6AddressGenerator::AddAllocated("0::0:4");
     NS_TEST_EXPECT_MSG_EQ(added, false, "address should not get allocated");
 
+    allocated = Ipv6AddressGenerator::IsAddressAllocated("0::0:9");
+    NS_TEST_EXPECT_MSG_EQ(allocated, true, "0::0:9 should be already allocated");
     added = Ipv6AddressGenerator::AddAllocated("0::0:9");
     NS_TEST_EXPECT_MSG_EQ(added, false, "address should not get allocated");
 
+    allocated = Ipv6AddressGenerator::IsAddressAllocated("0::0:16");
+    NS_TEST_EXPECT_MSG_EQ(allocated, true, "0::0:16 should be already allocated");
     added = Ipv6AddressGenerator::AddAllocated("0::0:16");
     NS_TEST_EXPECT_MSG_EQ(added, false, "address should not get allocated");
 
+    allocated = Ipv6AddressGenerator::IsAddressAllocated("0::0:21");
+    NS_TEST_EXPECT_MSG_EQ(allocated, true, "0::0:21 should be already allocated");
     added = Ipv6AddressGenerator::AddAllocated("0::0:21");
     NS_TEST_EXPECT_MSG_EQ(added, false, "address should not get allocated");
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/test/ipv6-ripng-test.cc ns-3.40/src/internet/test/ipv6-ripng-test.cc
--- ns-3.39/src/internet/test/ipv6-ripng-test.cc	2023-07-05 14:23:47.865427500 -0700
+++ ns-3.40/src/internet/test/ipv6-ripng-test.cc	2023-09-27 13:30:37.666839100 -0700
@@ -556,7 +556,7 @@
         std::list<RipNgRte> rtes = hdr.GetRteList();
 
         // validate the RTEs before processing
-        for (std::list<RipNgRte>::iterator iter = rtes.begin(); iter != rtes.end(); iter++)
+        for (auto iter = rtes.begin(); iter != rtes.end(); iter++)
         {
             if (iter->GetPrefix() == "2001:1::")
             {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/test/tcp-advertised-window-test.cc ns-3.40/src/internet/test/tcp-advertised-window-test.cc
--- ns-3.39/src/internet/test/tcp-advertised-window-test.cc	2023-07-05 14:23:47.865427500 -0700
+++ ns-3.40/src/internet/test/tcp-advertised-window-test.cc	2023-09-27 13:30:37.666839100 -0700
@@ -447,7 +447,7 @@
 TcpAdvWindowOnLossTest::CreateReceiverErrorModel()
 {
     Ptr<TcpSeqErrorModel> m_errorModel = CreateObject<TcpSeqErrorModel>();
-    for (std::vector<uint32_t>::iterator it = m_toDrop.begin(); it != m_toDrop.end(); ++it)
+    for (auto it = m_toDrop.begin(); it != m_toDrop.end(); ++it)
     {
         m_errorModel->AddSeqToKill(SequenceNumber32(*it));
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/test/tcp-bytes-in-flight-test.cc ns-3.40/src/internet/test/tcp-bytes-in-flight-test.cc
--- ns-3.39/src/internet/test/tcp-bytes-in-flight-test.cc	2023-07-05 14:23:47.865427500 -0700
+++ ns-3.40/src/internet/test/tcp-bytes-in-flight-test.cc	2023-09-27 13:30:37.666839100 -0700
@@ -141,7 +141,7 @@
 TcpBytesInFlightTest::CreateReceiverErrorModel()
 {
     Ptr<TcpSeqErrorModel> m_errorModel = CreateObject<TcpSeqErrorModel>();
-    for (std::vector<uint32_t>::iterator it = m_toDrop.begin(); it != m_toDrop.end(); ++it)
+    for (auto it = m_toDrop.begin(); it != m_toDrop.end(); ++it)
     {
         m_errorModel->AddSeqToKill(SequenceNumber32(*it));
     }
@@ -236,7 +236,7 @@
 {
     if (who == SENDER)
     {
-        static SequenceNumber32 retr = SequenceNumber32(0);
+        static SequenceNumber32 retr(0);
         static uint32_t times = 0;
 
         if (m_greatestSeqSent <= h.GetSequenceNumber())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/test/tcp-fast-retr-test.cc ns-3.40/src/internet/test/tcp-fast-retr-test.cc
--- ns-3.39/src/internet/test/tcp-fast-retr-test.cc	2023-07-05 14:23:47.865427500 -0700
+++ ns-3.40/src/internet/test/tcp-fast-retr-test.cc	2023-09-27 13:30:37.666839100 -0700
@@ -443,7 +443,7 @@
         types.insert(types.begin(), TcpWestwoodPlus::GetTypeId());
         types.insert(types.begin(), TcpNewReno::GetTypeId());
 
-        for (std::list<TypeId>::iterator it = types.begin(); it != types.end(); ++it)
+        for (auto it = types.begin(); it != types.end(); ++it)
         {
             AddTestCase(new TcpFastRetrTest((*it), 5001, "Fast Retransmit testing"),
                         TestCase::QUICK);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/test/tcp-rate-ops-test.cc ns-3.40/src/internet/test/tcp-rate-ops-test.cc
--- ns-3.39/src/internet/test/tcp-rate-ops-test.cc	2023-07-05 14:23:47.865427500 -0700
+++ ns-3.40/src/internet/test/tcp-rate-ops-test.cc	2023-09-27 13:30:37.670839000 -0700
@@ -343,7 +343,7 @@
 TcpRateLinuxWithSocketsTest::CreateReceiverErrorModel()
 {
     Ptr<TcpSeqErrorModel> m_errorModel = CreateObject<TcpSeqErrorModel>();
-    for (std::vector<uint32_t>::iterator it = m_toDrop.begin(); it != m_toDrop.end(); ++it)
+    for (auto it = m_toDrop.begin(); it != m_toDrop.end(); ++it)
     {
         m_errorModel->AddSeqToKill(SequenceNumber32(*it));
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/test/tcp-rtt-estimation.cc ns-3.40/src/internet/test/tcp-rtt-estimation.cc
--- ns-3.39/src/internet/test/tcp-rtt-estimation.cc	2023-07-05 14:23:47.865427500 -0700
+++ ns-3.40/src/internet/test/tcp-rtt-estimation.cc	2023-09-27 13:30:37.670839000 -0700
@@ -232,9 +232,7 @@
 {
     Ptr<TcpSeqErrorModel> errorModel = CreateObject<TcpSeqErrorModel>();
 
-    std::vector<uint32_t>::iterator it;
-
-    for (it = m_toDrop.begin(); it != m_toDrop.end(); ++it)
+    for (auto it = m_toDrop.begin(); it != m_toDrop.end(); ++it)
     {
         errorModel->AddSeqToKill(SequenceNumber32((*it)));
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/test/tcp-rx-buffer-test.cc ns-3.40/src/internet/test/tcp-rx-buffer-test.cc
--- ns-3.39/src/internet/test/tcp-rx-buffer-test.cc	2023-07-05 14:23:47.865427500 -0700
+++ ns-3.40/src/internet/test/tcp-rx-buffer-test.cc	2023-09-27 13:30:37.670839000 -0700
@@ -60,7 +60,6 @@
 {
     TcpRxBuffer rxBuf;
     TcpOptionSack::SackList sackList;
-    TcpOptionSack::SackList::iterator it;
     Ptr<Packet> p = Create<Packet>(100);
     TcpHeader h;
 
@@ -83,7 +82,7 @@
                           "Sequence number differs from expected");
     sackList = rxBuf.GetSackList();
     NS_TEST_ASSERT_MSG_EQ(sackList.size(), 1, "SACK list should contain one element");
-    it = sackList.begin();
+    auto it = sackList.begin();
     NS_TEST_ASSERT_MSG_EQ(it->first, SequenceNumber32(501), "SACK block different than expected");
     NS_TEST_ASSERT_MSG_EQ(it->second, SequenceNumber32(601), "SACK block different than expected");
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/test/tcp-test.cc ns-3.40/src/internet/test/tcp-test.cc
--- ns-3.39/src/internet/test/tcp-test.cc	2023-07-05 14:23:47.865427500 -0700
+++ ns-3.40/src/internet/test/tcp-test.cc	2023-09-27 13:30:37.670839000 -0700
@@ -220,7 +220,7 @@
     m_serverRxPayload = new uint8_t[m_totalBytes];
     for (uint32_t i = 0; i < m_totalBytes; ++i)
     {
-        uint8_t m = (uint8_t)(97 + (i % 26));
+        auto m = (uint8_t)(97 + (i % 26));
         m_sourceTxPayload[i] = m;
     }
     memset(m_sourceRxPayload, 0, m_totalBytes);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet-apps/examples/ping-example.cc ns-3.40/src/internet-apps/examples/ping-example.cc
--- ns-3.39/src/internet-apps/examples/ping-example.cc	2023-07-05 14:23:47.825427300 -0700
+++ ns-3.40/src/internet-apps/examples/ping-example.cc	2023-09-27 13:30:37.646839100 -0700
@@ -115,8 +115,8 @@
 
     if (!destinationStr.empty())
     {
-        Ipv4Address v4Dst = Ipv4Address(destinationStr.c_str());
-        Ipv6Address v6Dst = Ipv6Address(destinationStr.c_str());
+        Ipv4Address v4Dst(destinationStr.c_str());
+        Ipv6Address v6Dst(destinationStr.c_str());
         if (v4Dst.IsInitialized())
         {
             useIpv6 = false;
@@ -131,8 +131,8 @@
 
     if (!sourceStr.empty())
     {
-        Ipv4Address v4Src = Ipv4Address(sourceStr.c_str());
-        Ipv6Address v6Src = Ipv6Address(sourceStr.c_str());
+        Ipv4Address v4Src(sourceStr.c_str());
+        Ipv6Address v6Src(sourceStr.c_str());
         if (v4Src.IsInitialized())
         {
             source = v4Src;
@@ -157,7 +157,7 @@
         }
         else
         {
-            Ipv4Address v4Dst = Ipv4Address(destinationStr.c_str());
+            Ipv4Address v4Dst(destinationStr.c_str());
             if (v4Dst.IsInitialized() && (v4Dst.IsBroadcast() || v4Dst.IsMulticast()))
             {
                 std::cout << "Specify a source address to use when pinging broadcast or multicast "
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet-apps/helper/dhcp-helper.cc ns-3.40/src/internet-apps/helper/dhcp-helper.cc
--- ns-3.39/src/internet-apps/helper/dhcp-helper.cc	2023-07-05 14:23:47.825427300 -0700
+++ ns-3.40/src/internet-apps/helper/dhcp-helper.cc	2023-09-27 13:30:37.646839100 -0700
@@ -67,7 +67,7 @@
 DhcpHelper::InstallDhcpClient(NetDeviceContainer netDevices) const
 {
     ApplicationContainer apps;
-    for (NetDeviceContainer::Iterator i = netDevices.Begin(); i != netDevices.End(); ++i)
+    for (auto i = netDevices.Begin(); i != netDevices.End(); ++i)
     {
         apps.Add(InstallDhcpClientPriv(*i));
     }
@@ -184,8 +184,7 @@
     }
 
     // check that the already fixed addresses are not in conflict with the pool
-    std::list<Ipv4Address>::iterator iter;
-    for (iter = m_fixedAddresses.begin(); iter != m_fixedAddresses.end(); iter++)
+    for (auto iter = m_fixedAddresses.begin(); iter != m_fixedAddresses.end(); iter++)
     {
         if (iter->Get() >= minAddr.Get() && iter->Get() <= maxAddr.Get())
         {
@@ -250,8 +249,7 @@
     }
 
     // check that the already fixed addresses are not in conflict with the pool
-    std::list<std::pair<Ipv4Address, Ipv4Address>>::iterator iter;
-    for (iter = m_addressPools.begin(); iter != m_addressPools.end(); iter++)
+    for (auto iter = m_addressPools.begin(); iter != m_addressPools.end(); iter++)
     {
         if (addr.Get() >= iter->first.Get() && addr.Get() <= iter->second.Get())
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet-apps/helper/ping6-helper.cc ns-3.40/src/internet-apps/helper/ping6-helper.cc
--- ns-3.39/src/internet-apps/helper/ping6-helper.cc	2023-07-05 14:23:47.825427300 -0700
+++ ns-3.40/src/internet-apps/helper/ping6-helper.cc	2023-09-27 13:30:37.646839100 -0700
@@ -59,7 +59,7 @@
 #pragma GCC diagnostic ignored "-Wdeprecated-declarations"
 
     ApplicationContainer apps;
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         Ptr<Node> node = *i;
         Ptr<Ping6> client = m_factory.Create<Ping6>();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet-apps/helper/ping-helper.cc ns-3.40/src/internet-apps/helper/ping-helper.cc
--- ns-3.39/src/internet-apps/helper/ping-helper.cc	2023-07-05 14:23:47.825427300 -0700
+++ ns-3.40/src/internet-apps/helper/ping-helper.cc	2023-09-27 13:30:37.646839100 -0700
@@ -65,7 +65,7 @@
 PingHelper::Install(NodeContainer c) const
 {
     ApplicationContainer apps;
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         apps.Add(InstallPriv(*i));
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet-apps/helper/radvd-helper.cc ns-3.40/src/internet-apps/helper/radvd-helper.cc
--- ns-3.39/src/internet-apps/helper/radvd-helper.cc	2023-07-05 14:23:47.825427300 -0700
+++ ns-3.40/src/internet-apps/helper/radvd-helper.cc	2023-09-27 13:30:37.646839100 -0700
@@ -120,8 +120,7 @@
 {
     ApplicationContainer apps;
     Ptr<Radvd> radvd = m_factory.Create<Radvd>();
-    for (RadvdInterfaceMapI iter = m_radvdInterfaces.begin(); iter != m_radvdInterfaces.end();
-         iter++)
+    for (auto iter = m_radvdInterfaces.begin(); iter != m_radvdInterfaces.end(); iter++)
     {
         if (!iter->second->GetPrefixes().empty())
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet-apps/helper/v4ping-helper.cc ns-3.40/src/internet-apps/helper/v4ping-helper.cc
--- ns-3.39/src/internet-apps/helper/v4ping-helper.cc	2023-07-05 14:23:47.825427300 -0700
+++ ns-3.40/src/internet-apps/helper/v4ping-helper.cc	2023-09-27 13:30:37.646839100 -0700
@@ -57,7 +57,7 @@
 V4PingHelper::Install(NodeContainer c) const
 {
     ApplicationContainer apps;
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         apps.Add(InstallPriv(*i));
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet-apps/helper/v4traceroute-helper.cc ns-3.40/src/internet-apps/helper/v4traceroute-helper.cc
--- ns-3.39/src/internet-apps/helper/v4traceroute-helper.cc	2023-07-05 14:23:47.825427300 -0700
+++ ns-3.40/src/internet-apps/helper/v4traceroute-helper.cc	2023-09-27 13:30:37.646839100 -0700
@@ -56,7 +56,7 @@
 V4TraceRouteHelper::Install(NodeContainer c) const
 {
     ApplicationContainer apps;
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         apps.Add(InstallPriv(*i));
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet-apps/model/dhcp-header.cc ns-3.40/src/internet-apps/model/dhcp-header.cc
--- ns-3.39/src/internet-apps/model/dhcp-header.cc	2023-07-05 14:23:47.829427500 -0700
+++ ns-3.40/src/internet-apps/model/dhcp-header.cc	2023-09-27 13:30:37.646839100 -0700
@@ -42,7 +42,7 @@
     m_secs = 0;
     m_hops = 0;
     m_flags = 0;
-    Ipv4Address addr = Ipv4Address("0.0.0.0");
+    Ipv4Address addr("0.0.0.0");
     m_yiAddr = addr;
     m_ciAddr = addr;
     m_siAddr = addr;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet-apps/model/dhcp-server.cc ns-3.40/src/internet-apps/model/dhcp-server.cc
--- ns-3.39/src/internet-apps/model/dhcp-server.cc	2023-07-05 14:23:47.829427500 -0700
+++ ns-3.40/src/internet-apps/model/dhcp-server.cc	2023-09-27 13:30:37.646839100 -0700
@@ -160,7 +160,7 @@
     uint32_t range = m_maxAddress.Get() - m_minAddress.Get() + 1;
     for (uint32_t searchSeq = 0; searchSeq < range; searchSeq++)
     {
-        Ipv4Address poolAddress = Ipv4Address(m_minAddress.Get() + searchSeq);
+        Ipv4Address poolAddress(m_minAddress.Get() + searchSeq);
         if (poolAddress != myOwnAddress)
         {
             NS_LOG_LOGIC("Adding " << poolAddress << " to the pool");
@@ -259,7 +259,7 @@
 
     NS_LOG_INFO("DHCP DISCOVER from: " << from.GetIpv4() << " source port: " << from.GetPort());
 
-    LeasedAddressIter iter = m_leasedAddresses.find(sourceChaddr);
+    auto iter = m_leasedAddresses.find(sourceChaddr);
     if (iter != m_leasedAddresses.end())
     {
         // We know this client from some time ago
@@ -425,8 +425,7 @@
     NS_ASSERT_MSG(m_leasedAddresses.find(cleanedCaddr) == m_leasedAddresses.end(),
                   "Client has already an active lease: " << m_leasedAddresses[cleanedCaddr].first);
 
-    AvailableAddress::iterator it =
-        find(m_availableAddresses.begin(), m_availableAddresses.end(), addr);
+    auto it = find(m_availableAddresses.begin(), m_availableAddresses.end(), addr);
     NS_ASSERT_MSG(
         it == m_availableAddresses.end(),
         "Required address is not available (perhaps it has been already assigned): " << addr);
